Licensing terms for Intermesh Group-Office Professional

The following licensing terms regulate the scope of the
right of use that you acquire through the aforesaid software. If you
do not agree to the licensing terms, Intermesh will not grant
you the right to use the software. You should thus read through the
licensing terms carefully before signing the contract with Intermesh.
The signing of this contract indicates that you have accepted
the licensing terms which then become a constituent part of the
contract concluded between you and Intermesh.

1. Licensing

a) Test installation: Intermesh provides the software for a
test period so that customers can evaluate on their own whether the
program meets their requirements. The test period begins at the time
of installation. The test period is limited to 30 days. The number of
users in this period is not restricted. If a customer decides not to
purchase a license after the test period has expired, the software and
all its components (including database) must be irretrievably removed
from the system, otherwise the Intermesh licensing terms and
those of the manufacturers will go into effect.

b) Installation and use: Intermesh agrees to grant you a
non-excluding license for installing and using the software for
internal business use that is not restricted to a particular time or
location.

c) Updates: You are entitled to product updates that apply to the
product. With updates we mean that you will recieve a new package when
a problem exists in the software. You will not recieve upgrades with new 
functionality. You will recieve updates automatically from Intermesh.

d) Support: Intermesh offers technical support by e-mail or phone.
Response will follow within 24 hours.

e) Backup copy: You are authorized to make one backup copy for the
sole purpose of saving your data. The backup copy must show the same
copyright and ownership information contained in the original
software.

f) Licenses: Intermesh grants you the right to
access the software simultaneously from as many workstations as
you like. But you may only install the software on one host or machine.
The software will be encoded and you will need to identify your server by 
providing the IP address, Hardware address and hostname.

g) Transferring ownership of the software: You are only authorized to
transfer ownership of the software to a third party if you transfer
the complete software including all documentation and at the same time
destroy any copies of the software and parts of the
documentation. Moreover, the recipient of the software must agree in
writing to the licensing terms stipulated herein. You agree to notify
Intermesh in writing immediately of any transfer of ownership
to third parties.

2. Prohibited use

Intermesh reserves all rights not expressly granted. Using the
software in the ways described below is prohibited:

a) Modification, decompilation: Any modification, editing, compilation
or decompilation of the software is prohibited. However, Intermesh 
does agree to provide the required source-code information in
order to restore interoperability for a suitable fee (developer's
license).

b) Sales, sublicensing, renting, leasing: With the exception of the
right to transfer ownership set forth in 1g), you are not authorized
to sell the software. The same applies to sublicensing, renting,
leasing or other forms of provisioning the software to third parties.

3. Warranty

a) No absolute error-free software: Intermesh expressly states
that current technology does not make it possible to develop 100%
error-free software products. No liability will be assumed for typical
software errors that do not effect or only slightly impair operation.

b) Requirement to inspect and give notice of defects: Intermesh must be
informed immediately of any errors found during such an
inspection. Intermesh must be informed of any other errors
immediately after they are discovered in writing. The written
notification must contain a sufficiently precise description of the
error that will allow Intermesh to identify, reproduce, and
eliminate the error.

c) Warranty rights: Intermesh will offer compensation for
justified customer claims by correcting the defect(s) or replacing the
defective part(s). If a defect cannot be corrected within a suitable
period of time, or if the corrective measure or replacement has
failed, the customer is entitled to a reduction in the purchase price
(diminution) or cancellation of the contract (recision).

d) Invalidation of warranty: The warranty will be invalidated if the
customer modifies or edits the software in a way that is not
authorized by Intermesh unless the customer is able to
demonstrate that the defect in question was not caused by the
modification, in whole or in part, and that the ability to eliminate
the defect has not been aggravated by the modification.

e) Costs: In legitimate warranty cases, the customer will receive a
replacement free of charge. If it is ascertained that service or
repair work was not covered by the warranty, the customer is required
to remunerate Intermesh for the services rendered according to
its general payment rates.

4. Liability

a) Customer Remedies. Intermesh's and its suppliers' entire liability 
and your exclusive remedy for any breach of the foregoing warranty 
shall be, at Intermesh's option, either (i) return of the purchase 
price paid for the license, if any, or (ii) replacement of the 
defective media in which the Software is contained. You must return 
the defective media to Intermesh at your expense with a copy of your 
receipt. This limited warranty is void if the defect has resulted
from accident, abuse, or misapplication. Any replacement media will 
be warranted for the remainder of the original warranty period.

b) Warranty Disclaimer. Except for the limited warranty set forth 
herein, THE SOFTWARE IS PROVIDED "AS IS." TO THE MAXIMUM EXTENT 
PERMITTED BY APPLICABLE LAW, INTERMESH DISCLAIMS ALL WARRANTIES,
 EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO IMPLIED
 WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, 
AND NONINFRINGEMENT WITH RESPECT TO THE SOFTWARE AND THE 
ACCOMPANYING DOCUMENTATION. YOU ASSUME RESPONSIBILITY FOR SELECTING 
THE SOFTWARE TO ACHIEVE YOUR INTENDED RESULTS, AND FOR THE 
INSTALLATION OF, USE OF, AND RESULTS OBTAINED FROM THE SOFTWARE. 
WITHOUT LIMITING THE FOREGOING PROVISIONS, INTERMESH MAKES NO 
WARRANTY THAT THE SOFTWARE WILL BE ERROR-FREE OR FREE FROM 
INTERRUPTIONS OR OTHER FAILURES OR THAT THE SOFTWARE WILL MEET
 YOUR REQUIREMENTS. SOME STATES AND JURISDICTIONS DO NOT ALLOW
 LIMITATIONS ON IMPLIED WARRANTIES, SO THE ABOVE LIMITATION MAY 
NOT APPLY TO YOU. The foregoing provisions shall be enforceable 
to the maximum extent permitted by applicable law. 

c) Limitation of Liability. UNDER NO CIRCUMSTANCES AND UNDER NO LEGAL
THEORY, WHETHER IN TORT, CONTRACT, OR OTHERWISE, SHALL INTERMESH OR 
ITS SUPPLIERS BE LIABLE TO YOU OR TO ANY OTHER PERSON FOR ANY
INDIRECT,SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES OF ANY
CHARACTER INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF 
GOODWILL, WORK STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR FOR ANY
AND ALL OTHER DAMAGES OR LOSSES. IN NO EVENT WILL INTERMESH BE LIABLE 
FOR ANY DAMAGES IN EXCESS OF THE LIST PRICE INTERMESH CHARGES FOR A
LICENSE TO THE SOFTWARE, EVEN IF INTERMESH SHALL HAVE BEEN ADVISED OF
THE POSSIBILITY OF SUCH DAMAGES. THIS LIMITATION OF LIABILITY SHALL 
NOT APPLY TO LIABILITY FOR DEATH OR PERSONAL INJURY TO THE EXTENT THAT
APPLICABLE LAW PROHIBITS SUCH LIMITATION. FURTHERMORE, SOME STATES AND 
JURISDICTIONS DO NOT ALLOW THE EXCLUSION OR LIMITATION OF INCIDENTAL 
OR CONSEQUENTIAL DAMAGES, SO THIS LIMITATION AND EXCLUSION MAY NOT
APPLY TO YOU. The foregoing provisions shall be enforceable to the 
maximum extent permitted by applicable law.

5. High Risk Activities. The Software is not fault- tolerant and is not
designed or intended for use in hazardous environments requiring 
fail-safe performance, including without limitation, in the operation
of nuclear facilities, aircraft navigation or communication systems,
air traffic control, weapons systems, direct life-support machines, or
any other application in which the failure of the Software could lead 
directly to death, personal injury, or severe physical or property
damage (collectively, "High Risk Activities"). Intermesh expressly 
disclaims any express or implied warranty of fitness for High Risk 
Activities. 

6.Intermesh customer contact. If you have any questions regarding 
this contract. Contact using the following information:

Intermesh
Wethouder Schuurmanslaan 361
5231 MN 's-Hertogenbosch 
tel. +31619864268
e-mail: info@intermesh.nl  
